<?php
declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\Model\DataLayer\Generator;

use Flat101\EnhancedEcommerce\Model\DataLayer\Dto;
use Flat101\EnhancedEcommerce\Model\UnsetProperty;

class CheckoutOptionStep
{
    use UnsetProperty;

    private const EVENT = 'checkoutOption';

    private const EVENT_CATEGORY = 'enhanced ecommerce';
    private const EVENT_ACTION = 'checkout';

    public function onCheckoutOptionStep(
        int $step,
        string $option
    ): Dto\Ecommerce
    {
        $actionField = new Dto\Cart\ActionField();
        $actionField->step = $step;
        $actionField->option = $option;

        $optionActionField = new Dto\Cart\OptionActionFields();
        $optionActionField->actionField = $actionField;

        $checkoutOption = new Dto\Cart\Checkout();
        $checkoutOption->checkout = $optionActionField;

        $this->unset($checkoutOption, ['currencyCode']);

        $ecommerce = new Dto\Ecommerce();
        $ecommerce->event = self::EVENT;
        $ecommerce->ecommerce = $checkoutOption;

        $this->unset($ecommerce, ['eventCategory','eventAction','eventLabel']);

        return $ecommerce;
    }
}
