define([
    'jquery'
], function ($) {
    'use strict';

    function initBefore() {
        window.dataLayer = window.dataLayer || [];
    }

    function dataLayerPush(data) {
        initBefore();
        dataLayer.push(data);
    }

    return function (options, element) {
        $(element).click(function (event) {
            let prodId = null;
            if(typeof($(element).closest('.product-item-info').attr('id')) != "undefined"){
                let prodIdElement = $(element).closest('.product-item-info').attr('id') ? $(element).closest('.product-item-info').attr('id') : $(element).closest('.product-item').attr('id');
                let array = prodIdElement.split('_');

                if (array.length > 0) {
                    prodId = prodIdElement.split('_')[1];
                }
            } else {
                let tag = $(element).closest('.product-item-info');
                prodId = tag.find('.price-box.price-final_price').attr('data-product-id');

            }


            if (_.has(options, 'click_data') && _.isObject(options.click_data.GA4)) {
                let clickDataGa4 = JSON.stringify(options.click_data.GA4[prodId]);
                let clickDataUa = "{}";

                if (_.has(options.click_data, 'UA') && _.isObject(options.click_data.UA)) {
                    clickDataUa = JSON.stringify(options.click_data.UA[prodId]);
                }

                // TODO: Check the AJAX, it seems the response events are not processing
                $.ajax({
                    type: 'POST',
                    data: {
                        id: prodId,
                        currentUrl: options.currentUrl,
                        refererUrl: options.refererUrl,
                        isDisabledUaDatalayer: options.isDisabledUaDatalayer,
                        clickDataGa4: clickDataGa4,
                        clickDataUa: clickDataUa
                    },
                    url: options.ajaxUrl,
                    success: (result, status) => {
                        if (_.isArray(result) && result.length > 0) {
                            result.forEach((item) => {
                                dataLayerPush(item, options.isDisabledUaDatalayer);
                            });
                        }
                    },
                    dataType: 'json'
                });
            }
        });
    };
});
